
-------------------------------------------------------------------------------
---- FTC RECORDS --------------------------------------------------------------
-------------------------------------------------------------------------------
--  [record] = {
--           [1] = "3145728000";           // File Size
--           [2] = "143.483";              // Transfer time
--           [3] = "21410.201905452213";   // Transfer rate (KB/s)
--           [4] = "1048576";              // Buffer Size used
--         };
-------------------------------------------------------------------------------

-- Calculate average
local function calculateAverage(result)
	local nrecords = #result
	local totalspeed =0
	for _,speed in ipairs(result) do
        totalspeed = totalspeed + speed
	end
    return totalspeed / nrecords
end

local function getFileRecords(filename)
	local file = io.open(filename,"r")

	if not file then
		print("Erro ao abrir o arquivo: ".. filename)
		os.exit(1)
	end

	local result = {}
	local tmp = {}
    local bufferSize = 1024*1024
    local lineCount = 0
	for line in file:lines() do
        lineCount = lineCount + 1
		local t = fromCSV(line)
		
        if t then
            table.insert(tmp, t[3] )
        end

        if lineCount == 3 then
            lineCount=0
            result[bufferSize] = calculateAverage(tmp)
            bufferSize = bufferSize - 1024
        end
	end
	
	file:close()

	return result
end


function processServerBuffer(descritor)
	local file = io.open( descritor.output ,"w")

	if not file then
		print("Erro ao abrir o arquivo: " .. descritor.output)
		os.exit(1)
	end

	for i=1,#descritor.files do
		local implementation = descritor.files[i].name
		local filename = descritor.files[i].filename

		local result = getFileRecords(filename)
		
		calculateAverage(result)
		
		file:write("#".. implementation .. "\n")
		for size,speed in orderedPairs(result) do
            file:write(size .. "   " .. speed .. "\n")
		end
		file:write("\n\n\n")

	end

	file:close()
end 

