
-------------------------------------------------------------------------------
---- FTC SERVER RECORDS -------------------------------------------------------
-------------------------------------------------------------------------------
--  [record] = {
--           [1] = "3145728000";           // File Size
--           [2] = "143.483";              // Transfer time
--           [3] = "21410.201905452213";   // Transfer rate (KB/s)
--           [4] = "1048576";              // Buffer Size used
--         };
-------------------------------------------------------------------------------

local function fromServerLog(line)
    if string.match(line,"Numero",10) then
        local time = string.match(line,"(%d+)",2)/1000
        return time,1
    elseif string.match(line,"foi fechado",10) then
        local time = string.match(line,"(%d+)",2)/1000
        return time,-1
    end

    return nil
end


local function getServerClientRecords(filename)
	local file = io.open(filename,"r")

	if not file then
		print("Erro ao abrir o arquivo: ".. filename)
		os.exit(1)
	end

	local result = {}
    local clientCount = 0;
	for line in file:lines() do
		local t,count = fromServerLog(line)
		if t then 
            clientCount = clientCount + count
			result[t]= clientCount
		end
	end
	
	file:close()

	return result
end

function processServerLog(descritor)
	local file = io.open( descritor.output ,"w")

	if not file then
		print("Erro ao abrir o arquivo: " .. descritor.output)
		os.exit(1)
	end

	for i=1,#descritor.files do
		local implementation = descritor.files[i].name
		local filename = descritor.files[i].filename

		local result = getServerClientRecords(filename)
		
		file:write("#".. implementation .. "\n")
		for time,clientCount in orderedPairs(result) do
				file:write(time .. "   " .. clientCount ..  "\n")
		end
		file:write("\n\n\n")

	end

	file:close()
end 
