require("tableshow")
-------------------------------------------------------------------------------
---- FTC MULTICLIENT RECORDS --------------------------------------------------
-------------------------------------------------------------------------------
--  [record] = {
--           [1] = "3145728000";           // File Size
--           [2] = "143.483";              // Transfer time
--         };
-------------------------------------------------------------------------------

local function addRecord(result,record)
    local duration = math.floor(record[2])
	local speed = record[3]
	local timestamp = math.floor(record[6])
    
    local value
    for i=timestamp,(timestamp+duration) do
        value = result[i]
        if not value then
            result[i] = speed
        else
            result[i] = value + speed
        end
    end

end


local function getMultiClientRecords(filename)
	local result = {}
    
    for clientFilename in io.popen("ls " .. filename):lines() do
        local file = io.open(clientFilename,"r")

        if not file then
            print("Erro ao abrir o arquivo: ".. filename)
            os.exit(1)
        end

        for line in file:lines() do
            local t = fromCSV(line)
            if t then 
                addRecord(result,t)
            else
                break
            end
        end
        
        file:close()
    end

	return result
end

function processMultiClient(descritor)
	local file = io.open( descritor.output ,"w")

	if not file then
		print("Erro ao abrir o arquivo: " .. descritor.output)
		os.exit(1)
	end

	for i=1,#descritor.files do
		local implementation = descritor.files[i].name
		local filename = descritor.files[i].filename

		local result = getMultiClientRecords(filename)
		
		file:write("#".. implementation .. "\n")
		for time,speed in orderedPairs(result) do
            file:write(time .. "   " .. speed ..  "\n")
		end
		file:write("\n\n\n")
	end

	file:close()
end 
