package ftc.server.v1_2;

import java.io.IOException;

import tecgraf.ftc_1_2.server.DefaultFileProvider;
import tecgraf.ftc_1_2.server.DefaultFileServerExceptionHandler;
import tecgraf.ftc_1_2.server.FileServer;
import ftc.FTCServerVersionAdapter;
import ftc.ServerConfig;

public class FTCServerV1_2 implements FTCServerVersionAdapter {

  private FileServer server;

  public FTCServerV1_2(ServerConfig config) throws IOException {
    // Instanciando o FileServer
    DefaultFileProvider fileProvider = new DefaultFileProvider();
    server = new FileServer(fileProvider);
    server.setConfig(new FtcServerConfig(config));
    server.setExceptionHandler(new DefaultFileServerExceptionHandler());

  }

  @Override
  public void createFileChannelInfo(Object o, byte[] fileId, byte[] accessKey,
    boolean useTransferTo) throws Exception {
    server.createFileChannelInfo(o, fileId, accessKey, useTransferTo);
  }

  @Override
  public void dispatch() {
    server.dispatch();
  }

  @Override
  public void stop() {
    server.stop();
  }

}
