package ftc.server.v1_4_0;

import java.io.IOException;

import tecgraf.ftc_1_4.server.DefaultDataProvider;
import tecgraf.ftc_1_4.server.DefaultFileServerExceptionHandler;
import tecgraf.ftc_1_4.server.FileServer;
import ftc.FTCServerVersionAdapter;
import ftc.ServerConfig;

public class FTCServerV1_4_0 implements FTCServerVersionAdapter {

  FileServer server = null;

  public FTCServerV1_4_0(ServerConfig config) throws IOException {
    // Instanciando o FileServer
    DefaultDataProvider fileProvider = new DefaultDataProvider();
    server = new FileServer(fileProvider);
    server.setConfig(new FtcServerConfig(config));
    server.setExceptionHandler(new DefaultFileServerExceptionHandler());
  }

  @Override
  public void createFileChannelInfo(Object o, byte[] fileId, byte[] accessKey,
    boolean useTransferTo) throws Exception {
    server.createFileChannelInfo(o, fileId, accessKey, useTransferTo);
  }

  @Override
  public void dispatch() {
    server.dispatch();
  }

  @Override
  public void stop() {
    server.stop();
  }

}
