local io = io
local print = print
local ipairs = ipairs
local pairs = pairs
local string = string
local PARAMS = ftcbench.parameters 

module("ftcbench.iozone")

local name = "Iozone"

local command = "./bin/iozone -Ra -g %dk -i 0 -i 1 -f /tmp/iozone.tmp"

local conf 

function setConfig(config)
    conf = config
end

function getName()
    return name
end

function run()
    local file =  io.open("/proc/meminfo","r")
    if not file then
        return nil , name , "Could not read total memory from /proc/meminfo"
    end

    local memorySize = 0
    for line in file:lines() do
        if string.find(line, "MemTotal") ~= nil then
             memorySize = string.match(line,"[%d]+")
            break
        end
    end

    file:close()
    if memorySize == 0 then
        return nil , name , "Could not read total memory from /proc/meminfo"
    end

    local cmd = string.format(command, memorySize * 2)

    print("This test can take serveral minutes.")

    if conf.Debug then
        print("Command: " .. cmd )
    end

    local output = io.popen( cmd )

    if not output then
        return nil , name .. " Error: Could not execute the given command!"
    end

    local outputFile , err  = io.open(conf.OutputDir .. "iozone.txt", "a+")
    
    if not outputFile then
        return nil , name .. " Error: " .. err
    end
    outputFile:seek("end")
    outputFile:write(output:read("*all"))
    output:close()
    outputFile:close()
end

